local _name, _addon = ...;

local function am(msg)
	msg = msg or "nil";
	DEFAULT_CHAT_FRAME:AddMessage(msg);
end

local DEFAULT_CASE = "Common";
local DO_ASK = 0;
local DO_ACCEPT = 1;
local DO_DENY = 2;
local DO_ALT = 3;
local DO_HIDE = 9;

----------------------------------------------------------------------------------------
_addon.cases = {
	[DEFAULT_CASE] = {
		[DO_ASK] = function(dialog, ...)
			--do nothing
		end,
		[DO_ACCEPT] = function(dialog, ...)
			local info = StaticPopupDialogs[dialog.which];
			if info and info.OnAccept then
				info.OnAccept(dialog, dialog.data, dialog.data2);
			end
			StaticPopup_Hide(dialog.which);
		end,
		[DO_DENY] = function(dialog, ...)
			local info = StaticPopupDialogs[dialog.which];
			if info and info.OnCancel then
				info.OnCancel(dialog, dialog.data, "clicked");
			end
			StaticPopup_Hide(dialog.which);
		end,
		[DO_ALT] = function(dialog, ...)
			local info = StaticPopupDialogs[dialog.which];
			if info and info.OnAlt then
				info.OnAlt(dialog, dialog.data, "clicked");
			end
			StaticPopup_Hide(dialog.which);
		end,
		[DO_HIDE] = function(dialog, ...)
			local info = StaticPopupDialogs[dialog.which];
			if info and info.OnHide then
				info.OnHide(dialog, dialog.data);
			end
			StaticPopup_Hide(dialog.which);
		end,
	},
	["DELETE_ITEM"] = {
		info = "Caution, hold modifier key to confirm each item-deleting.",
		[DO_ACCEPT] = function(dialog, ...)
			if IsModifierKeyDown() then
				StaticPopupDialogs["DELETE_ITEM"].OnAccept(dialog, dialog.data, dialog.data2);
			else
				--PlaySound("igMainMenuOpen");
			end
		end,
	},
	["DELETE_GOOD_ITEM"] = {
		info = "Caution, hold modifier key to confirm each item-deleting.",
		[DO_ACCEPT] = function(dialog, ...)
			if IsModifierKeyDown() then
				StaticPopupDialogs["DELETE_GOOD_ITEM"].OnAccept(dialog, dialog.data, dialog.data2);
			else
				--PlaySound("igMainMenuOpen");
			end
		end,
	},
	["LOOT_BIND"] = {
		[DO_ACCEPT] = function(dialog, ...)
			_addon:DelayExecute(dialog, function(self, ...)
				local info = StaticPopupDialogs["LOOT_BIND"];
				info.OnAccept(self, self.data, self.data2);
				StaticPopup_Hide("LOOT_BIND");
				--trigger next loot
				for index=1, GetNumLootItems() do
					if GetLootSlotLink(index) then
						LootSlot(index);
						return;
					end
				end
			end);
		end,
	},
	["VOID_DEPOSIT_CONFIRM"] = {
		[DO_ACCEPT] = function(dialog, ...)
			_addon:DelayExecute(dialog, function(self, ...)
				local info = StaticPopupDialogs["VOID_DEPOSIT_CONFIRM"];
				info.OnAccept(self, self.data, self.data2);
				StaticPopup_Hide("VOID_DEPOSIT_CONFIRM");
			end);
		end,
	},
	["TRANSMOGRIFY_BIND_CONFIRM"] = {
		[DO_ACCEPT] = function(dialog, ...)
			_addon:DelayExecute(dialog, function(self, ...)
				local info = StaticPopupDialogs["TRANSMOGRIFY_BIND_CONFIRM"];
				info.OnAccept(self, self.data, self.data2);
				StaticPopup_Hide("TRANSMOGRIFY_BIND_CONFIRM");
			end);
		end,
	},
	["SET_GUILDPLAYERNOTE"] = {
		blocked = 1,
		info = "Leave me alone!",
	},
	["CONFIRM_GLYPH_PLACEMENT"] = {
		blocked = 1,
		info = "Blizzard protected function. Leave it alone.",
	},
};

